import chimera, numpy
from numpy import array, zeros

def centroid(atoms_L):
    sum = zeros(3, float)
    for a in atoms_L:
        sum += array(a.coord())
    return sum/float(len(atoms_L))

def getAtomsFromResidue(molecule, residueChain, residueType, residuePosition, names_L):
    print " "
    ret_L = []
    for r in molecule.residues:
        if r.id.chainId == residueChain and r.id.position == residuePosition:
            if residueType != "" and r.type != residueType:
                print "Mismatch error. Unexpected residue type for given position."
                return
            for a in r.atoms:
                if a.name in names_L:
                    ret_L.append(a)
    return ret_L
                    
#-----------------------------------------------------------------------------------
prot = chimera.openModels.open("3I5L", type = 'PDB')[0]

atomNamesInRings_D = {}
atomNamesInRings_D["6.B"] = ["C13", "C14", "N5", "C16", "N6"]
atomNamesInRings_D["5.B"] = ["C18", "N9", "C19", "C20", "N8"]
atomNamesInRings_D["6.A"] = ["C39", "C40", "N17", "C42", "N18"]
atomNamesInRings_D["5.A"] = ["C44", "N21", "C45", "C46", "N20"]

for k in atomNamesInRings_D.keys():
    pos = int(k.split('.')[0])
    chain = k.split('.')[1]
    oxyAtomCoord = array(getAtomsFromResidue(prot, chain, "", pos, ["O4'"])[0].coord())
    cent = centroid(getAtomsFromResidue(prot, "B", "1P1", 500, atomNamesInRings_D[k]))
    dist = numpy.linalg.norm(oxyAtomCoord - cent)
    print "Distance between Oxy_" + k + " and its ring: = %7.3f" % dist
    
