import chimera
from chimera import runCommand

from StructBio.HBonds import HBondDicts
from StructBio.HBonds.generate_hBond_plates import Generate_hBond_plates
from StructBio.SSEs.tubesForSSEs import TubesForSSEs

#==============================================================================
# Suggestions: try 2BYR, 2BYS, 3EAM, 7AHL
# Try 1AON, but be patient....
pdbIDchars = raw_input("Type in 4 character PDB ID or PDB file name: \n")
prot = chimera.openModels.open(pdbIDchars, type="PDB")[0]

Generate_hBond_plates(prot, HBondDicts(prot, 0.5, 35.0))
    
TubesForSSEs(prot, strands = False)

runCommand("sel ligand")
runCommand("repr sphere sel")
runCommand("color byelement")
runCommand("display sel")
runCommand("~sel")

