import numpy
from numpy import array

from StructBio.Scenographics.surfaces import Surfaces


wrapThreshold = 19

pd = Surfaces()

for wC in range(wrapThreshold - 10, wrapThreshold + 11):
    normalizedWC = (min(max(wC, wrapThreshold - 10), wrapThreshold + 10) - wrapThreshold)/10.0
    greenEntry = .5 - .5*normalizedWC
    redBlueEntry = .5 +  .5*normalizedWC
    plateColor = (redBlueEntry, greenEntry, redBlueEntry)
    x = wC*1.1
    v1 = array([x, 1., 0.])
    v2 = array([x + 1., 1., 0.])
    v3 = array([x + 1., 0., 0.])
    v4 = array([x, 0., 0.])
    pd.addPolygon([v1, v2, v3, v4], plateColor, 1.0)


pd.display()
