import chimera

from StructBio.Utilities.shellNeighbors import Shell
from StructBio.Utilities.hiLite import HiLiter

pdbIDchars = raw_input("Type in 4 character PDB ID or PDB file name: \n")
prot = chimera.openModels.open(pdbIDchars, type="PDB")[0]
atomList = prot.atoms

minR = 0.0
maxR = 10.0

shell = Shell(atomList, minR, maxR)

hiLiter = HiLiter(prot)
hiLiter.setVerbose(True)

print "Hit Enter key to go through alpha carbons"

for res in prot.residues:
    if not('CA' in res.atomNames()): continue
    centerAtom = res.findAtom('CA')
    resNeighbours_L = shell.listOfNeighboringResidues(centerAtom.residue)
    resNbrAlphas_L = []
    for r in resNeighbours_L:
        resNbrAlphas_L.append(r.findAtom("CA"))
    hiLiter.emphasize([centerAtom], resNbrAlphas_L, "Alpha Carbon: ",
                      "Alphas in neighboring residues: ")
    raw_input(" ")

hiLiter.clearEmphasis()


